// MTA4_TargetApp.cpp : Defines the entry point for the console application.
//

#include <tchar.h>
#include <stdio.h>

int GlobalStringTableMax = 256;
char ** GlobalStringTable;

void InitializeGlobalStringTable()
{
	GlobalStringTable = new char*[GlobalStringTableMax];

	for (int idx=0; idx<GlobalStringTableMax; ++idx)
	{
		GlobalStringTable[idx] = new char[64];
		sprintf_s(GlobalStringTable[idx], 64, "VALID_STRING_IDENTIFIER__0x%08X", idx);
	}
}

void DestroyGlobalStringTable()
{
	for (int idx=0; idx<GlobalStringTableMax; ++idx)
	{
		delete [] GlobalStringTable[idx];
		GlobalStringTable[idx] = NULL;
	}

	delete [] GlobalStringTable;
	GlobalStringTable = NULL;
}

struct MyType
{
	int Integer1;			// Doesn't do anything in this example
	int Integer2;			// This either
	
	int StringIndex;		// Index into the GlobalStringTable

	float _other;
	char _random;
	double _data;
};

int _tmain(int argc, _TCHAR* argv[])
{
	// put a breakpoint before the table is initialized

	MyType tooSoon;
	tooSoon.StringIndex = 20;

	printf("Creating the table\n");
	InitializeGlobalStringTable();

	MyType two;
	two.StringIndex = 50;

	MyType outOfRange;
	outOfRange.StringIndex = 300;

	// make the table bigger!
	printf("Destroying the table to resize it\n");
	DestroyGlobalStringTable();
	GlobalStringTableMax = 400;
	InitializeGlobalStringTable();

	printf("outOfRange is now valid\n");

	printf("Destroying the table again\n");
	DestroyGlobalStringTable();

	MyType tooLate;
	tooLate.StringIndex = 70;
	
	return 0;
}

